#!/bin/sh

. fwup-function

echo ">>"
echo ">> Set critical section"
echo ">>"

# rcflag partiton is erased for normal-operation
# set recovery flag
RCFLAG_TMP=/rcflag.bin
echo -n -e \\x01\\x00\\x00\\x00 > $RCFLAG_TMP
/usr/sbin/nandwrite -p /dev/mtd4 $RCFLAG_TMP

#cat /proc/driver/sy_basic_conf

#
#check nconfsave options
#
NAND_RFS_XCMD=/mnt/rfs/xcmd
if [ -x $NAND_RFS_XCMD ]; then
	NCONF_INIT=`grep -c _nconfsave.sh $NAND_RFS_XCMD`
fi


# for OEM model
get_oem_code()
{
	PNCODE=`grep SYF_STR1 /proc/driver/sy_basic_conf`
#   echo "$PNCODE"
	OEM_PNCODE=${PNCODE:39:2}
	OEM_PNCODE_SZ=${#OEM_PNCODE}
	echo "OEM pn-code : $OEM_PNCODE, $OEM_PNCODE_SZ"
	if [ $OEM_PNCODE_SZ -lt 2 ]; then
		echo "Wrong OEM code : $"
	fi
}

do_oem_work()
{
PATH_AUTH_TXT=etc/sysconfig/auth.txt
PATH_UEXT_TXT=etc/sysconfig/uext.txt

DF_KMW_AUTH_ADMIN_TXT=etc/oem_def_data/kmw_auth_admin.txt
DF_KMW_UEXT_TXT=etc/oem_def_data/kmw_uext.txt

	get_oem_code

	pushd .
	cd /mnt/rfs

	case "$OEM_PNCODE" in
		0w)
			cp -a $DF_KMW_AUTH_ADMIN_TXT $PATH_AUTH_TXT
			cp -a $DF_KMW_UEXT_TXT $PATH_UEXT_TXT
		;;
	esac
	popd
}



echo
echo "**********************************"
echo "*	Format rfs"
echo "**********************************"
echo

/bin/umount /mnt/rfs
/usr/sbin/flash_eraseall -j /dev/mtd9
mount -t jffs2 /dev/mtdblock9 /mnt/rfs
write_firmup_state 60 "Format rfs is done"
sync

cd /mnt/rfs

write_firmup_state 65 "Make rfs ..."
echo
echo "**********************************"
echo "*	Making rfs"
echo "**********************************"
echo

RSW_FILE=`ls /fw-work/rsw*tar.gz`

/bin/tar xzf $RSW_FILE
sync
write_firmup_state 70 "Make rfs ... Done"

write_firmup_state 75 "Restore ci ..."
# Make default config
DEF_CFG=etc/default_conf.tgz
echo
echo -n "Make default config  "
. etc/sysconfig/_conf.list
/bin/tar czf $DEF_CFG $FILES_TO_COMPRESS
echo "[ Done ]"
echo

echo
df -h
echo


CI_MTD=/dev/mtd7
CI_IMG=/ci.tar.gz
/usr/sbin/nanddump -o -B -f $CI_IMG $CI_MTD
/bin/gunzip -t $CI_IMG
if [ $? -eq 0 ]; then
	echo
	echo "**********************************"
	echo "*	Restore user config at new rfs"
	echo "**********************************"
	echo
	/bin/tar xzf $CI_IMG

	# make oem_def_init.log
	date >> etc/sysconfig/oem_def_init.log
	echo "ci restored" >> etc/sysconfig/oem_def_init.log

	if [ $NCONF_INIT -ge 1 ]; then
		do_oem_work
	fi
fi
rm $CI_IMG
sync
write_firmup_state 80 "Restore ci ... Done"

write_firmup_state 85 "Change ki ..."
echo
echo "**********************************"
echo "*	Change ki"
echo "**********************************"
echo
cd /fw-work/
KI_FILE=`ls ki_${FWFWID}*`
/mnt/rfs/usr/sbin/chgki $KI_FILE

IR_FILE=ir_ga.gz
if [ -f $IR_FILE ]; then
	echo
	echo "**********************************"
	echo "*	Change ir"
	echo "**********************************"
	echo
	/mnt/rfs/usr/sbin/chgir $IR_FILE
fi

make_normal_bootmode
write_firmup_state 90 "Change ki ... Done"

echo ">>"
echo ">> Clear critical section"
echo ">>"
/usr/sbin/flash_eraseall /dev/mtd4

#cat /proc/driver/sy_basic_conf

#
FWUPDATEPOST_FLAG=/fwupdate_done
/bin/touch $FWUPDATEPOST_FLAG

echo
echo "**********************************"
echo "*	Making rfs is done!"
echo "**********************************"
echo

# for web-polling
sleep 6

