#!/bin/sh

SENSOR=""
NEW_CFG=$1
SENSOR_CFGS_PATH="/opt/gm/app/sensor_cfg"
echo "$NEW_CFG" | grep -rq "^/opt/gm/app/sensor_cfg"
if [ "$?" == "0" ]; then
    #Pull path
    # echo "$NEW_CFG"
    NEW_CFG_FILE_NAME=$(basename "$NEW_CFG")
    NEW_CFG_FILE_NAME="${NEW_CFG_FILE_NAME%.*}"
    echo "$NEW_CFG_FILE_NAME"
    var=$(echo $NEW_CFG_FILE_NAME | awk -F"_" '{print $1,$2,$3}')
    set -- $var
    SENSOR="$2"
    CFG_NAME="$3"
else
    NEW_CFG_FILE_NAME=$(basename "$NEW_CFG")
    NEW_CFG_FILE_NAME="${NEW_CFG_FILE_NAME%.*}"
    echo "$NEW_CFG_FILE_NAME"
    var=$(echo $NEW_CFG_FILE_NAME | awk -F"_" '{print $1,$2,$3}')
    set -- $var
    SENSOR="$2"
    CFG_NAME="$3"
fi

if [ "$SENSOR" == "" ]; then
    echo "[ERROR] Could not find sensor name in \"$NEW_CFG_FILE_NAME\""
    exit 1
else
    if [ -f "${SENSOR_CFGS_PATH}/$SENSOR/${NEW_CFG_FILE_NAME}.cfg" ]; then
        if [ "$CFG_NAME" == "" ]; then
            echo "[ERROR] Wrong configuration file"
            exit 1
        else
            ln -sfn ${SENSOR_CFGS_PATH}/$SENSOR/${NEW_CFG_FILE_NAME}.cfg /opt/gm/app/isp320_${SENSOR}.cfg
            if [ "$?" == 0 ]; then
                echo "Configuration changed \"$NEW_CFG_FILE_NAME.cfg\""
            fi
        fi
    else
        echo "[ERROR] Could not find configuration in ${SENSOR_CFGS_PATH}/${SENSOR}/$NEW_CFG_FILE_NAME.cfg"
        exit 1
    fi
fi

exit 0